// serialServer.h

/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPFserial is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/
// Author: Marty Kraimer 
// Date: 13AUG98

enum serialServerStatus {
    serialServerStatusOK=0,
    serialServerStatusTimeout,
    serialServerStatusOverflow,
    serialServerStatusError
};

#define cmdWrite	0x1
#define cmdRead		0x2
#define cmdWriteRead	0x3
//Following are additional options for read
#define cmdFlush	0x4
#define cmdStartCircularBuffer 0x8
#define cmdStopCircularBuffer 0x10
#define cmdSetEom 	0x20

/*
 * cmdFlush - flush input buffer before starting read or writeRead
 * cmdStartCircularBuffer - accept input when no read outstanding
 * cmdStopCircularBuffer - dont accept input except when read is outstanding
 * cmdSetEom - change current eom
 *
 * for example the following could be specified
 * pserialServerStatus->cmd = cmdWriteRead|cmdFlush|cmdStartCircularBuffer;
*/

/* Generic serial server

SerialConfigMessage.
   This just calls SerialPort::config.
   It returns an Int32Message. status is 0 for success.

Char8ArrayMessage
       cmdWrite        : write request
       cmdRead         : read request
       cmdWriteRead    : writeRead request


       other fields from input message

       timeoutUnits	timeout units.
       timeout		The timeout value in timeoutUnits
       extra		If >0 the maximum number of chars to read 
       numberRetrys	Number of times to retry write and read if failure

       If cmdSetEom is set

       eomSize		If 0 dont look for eom
       eomString	1 ot 2 character eomString


       Return values
			A Char8ArrayMessage message, which
                        contains any input characters read

                        status is one of the serialServerStatus values
*/
